/* --------------------------------------------------------------------------
 * prelude.h:	Copyright (c) Mark P Jones 1991.   All rights reserved.
 *		See goferite.h for details and conditions of use etc...
 *		Gofer version 2.21 November 1991
 *
 *		Last updated 01/11/91 mpj
 *
 * Basic data type definitions, prototypes and standard macros including
 * machine dependent variations...
 * ------------------------------------------------------------------------*/

#include <stdio.h>

#define TURBOC   0      /* This version for IBM PC, using Turbo C 1.5      */
#define UNIX     1	/* This version for Sun 3/Sun 4 running SunOS 4.x  */

#define Void     void   /* older compilers object to: typedef void Void;   */
typedef unsigned Bool;
#define TRUE     1
#define FALSE    0
typedef char    *String;
typedef int      Int;
typedef long     Long;
typedef int      Char;
typedef unsigned Unsigned;

#ifdef __STDC__           /* To enable use of prototypes whenever possible */
#define Args(x) x
#else
#if TURBOC                /* K&R 1 does not permit `defined(__STDC__)' ... */
#define Args(x) x
#else
#define Args(x) ()
#endif
#endif

#if     TURBOC
#include <alloc.h>

#define local		   near pascal

extern  int  kbhit	   Args((void));	/* Call this to check for  */
#define allowBreak()	   kbhit()		/* break from program	   */

#define NUM_SYNTAX         100
#define NUM_TYCON          120
#define NUM_NAME           600
#define NUM_CLASSES        40
#define NUM_INSTS          100
#define NUM_SELECTS        100
#define NUM_INDEXES        2000
#define NUM_DICTS          4000
#define NUM_TEXT           4096
#define NUM_TYVARS         1000
#define NUM_FILES	   20
#define NUM_MODULES        64
#define NUM_STACK          2000
#define NUM_ADDRS          32000
#define NUM_FIXUPS         100
#define NUM_TUPLES         100
#define NUM_OFFSETS        500
#define NUM_CHARS          256
#define MINIMUMHEAP	   7500
#define MAXIMUMHEAP	   32765
#define DEFAULTHEAP        32765
#define MAXPOSINT          32767

#define FOPEN_WRITE	   "wt"		/* fopen *text* file for writing   */
#define FOPEN_APPEND	   "at"		/* fopen *text* file for append	   */

#define JMPBUF_ARRAY       0

#define minRecovery        1000
#define bitsPerWord        16
#define bitArraySize(n)    ((n)/bitsPerWord + 1)
#define placeInSet(n)      ((-(n)-1)>>4)
#define maskInSet(n)       (1<<((-(n)-1)&15))
#endif

#if     UNIX
#include <malloc.h>

#define allowBreak()
#define far
#define local

#define NUM_SYNTAX         100
#define NUM_TYCON          160
#define NUM_NAME           1600
#define NUM_CLASSES        40
#define NUM_INSTS          100
#define NUM_SELECTS        100
#define NUM_INDEXES        2000
#define NUM_DICTS          32000
#define NUM_TEXT           16384
#define NUM_TYVARS         3000
#define NUM_FILES	   20
#define NUM_MODULES        64
#define NUM_STACK          16000
#define NUM_ADDRS          80000
#define NUM_FIXUPS         100
#define NUM_TUPLES         100
#define NUM_OFFSETS        500
#define NUM_CHARS          256
#define MINIMUMHEAP	   7500
#define MAXIMUMHEAP	   0
#define DEFAULTHEAP        100000
#define MAXPOSINT          2147483647

#define FOPEN_WRITE	   "w"		/* fopen *text* file for writing   */
#define FOPEN_APPEND	   "a"		/* fopen *text* file for append	   */

#define JMPBUF_ARRAY       1

#define HASFLOATS	   /* Only if sizeof(float)<=sizeof(Cell)	   */

#define minRecovery        1000
#define bitsPerWord        32
#define bitArraySize(n)    ((n)/bitsPerWord + 1)
#define placeInSet(n)      ((-(n)-1)>>5)
#define maskInSet(n)       (1<<((-(n)-1)&31))
#endif

extern Int      strcmp     Args((String, String));
extern Int      strlen     Args((String));
extern char	*strcpy	   Args((String,String));
extern char     *strchr    Args((char *,int));  /* test membership in str  */
extern Void     exit       Args((Int));
extern Void     internal   Args((String));
extern Void far *farCalloc Args((Unsigned,Unsigned));

#ifdef  HASFLOATS
#define FloatImpType	   float
#define FloatPro	   double  /* type to use in prototypes		   */
				   /* strictly ansi (i.e. gcc) conforming  */
				   /* but breaks data hiding :-(	   */
#else
#define FloatImpType	   int     /*dummy*/
#define FloatPro	   int
#endif

#ifndef FILENAME_MAX	   /* should already be defined in an ANSI compiler*/
#define FILENAME_MAX 256
#else
#if     FILENAME_MAX < 256
#undef  FILENAME_MAX
#define FILENAME_MAX 256
#endif
#endif

#define DEF_EDITOR	   "vi"			/* replace with ((char *)0)*/
#define DEF_EDITLINE	   "vi +%d %s"		/* if no default editor rqd*/

/*-------------------------------------------------------------------------*/
